package ExFormat;


/**
 *
 * @author TeleVox
 */
import com.televox.TeleToken;

public class ExFormat {
    public static void main(String[] args) {

        TeleToken TVTT;
        int ret = 0;        
        int n;
        int OwnerId = 0x04030200;
        int[] FormatPass = new int[] {5,6,7,8,9};        
        String[] FeatureName ={"Owner ID:               ",
                               "NV Memory size:         ",
                               "Ram size:               ",
                               "Protect memory size:    ",
                               "Password table size:    ",
                               "Bits per password:      ",
                               "Counters:               ",
                               "Bits per counter:       ",
                               "Extension version:      "};

        TVTT = new TeleToken();        

        // pobranie wersji biblioteki / get library (dll) version
        ret = TVTT.GetVersion();

        if (ret==TeleToken.TVTTS_OK) {
            System.out.println("Odczyt wersji biblioteki");
            System.out.println("Wersja pliku : " + TVTT.Version + "." + TVTT.SubVersion);
            System.out.println("Wersja API : " + TVTT.ApiVersion);
        }
        else {
            System.out.println("Błąd odczytu wersji biblioteki : " + String.format("\t%X:%02X",ret>>8,ret&0xFF));
            return;
        }

        //pobranie uchwytu oraz odczyt właściwości tokenu / get token handle and properties
        ret = TVTT.FindToken(100, OwnerId, 0, 0);
        System.out.print("Otwarcie tokenu:");
        if (ret==TeleToken.TVTTS_OK)
            System.out.println("\t\tOK");
        else
            System.out.println("\t\t" + String.format("%X:%02X",ret>>8,ret&0xFF));

        for(n=0; n<TVTT.FeatureTblSize;n++) System.out.println(FeatureName[n] + "\t" + String.format("0x%02x", TVTT.FeatureTbl[n]));

        // odczytanie nr. seryjnego TeleTokenu / get token serial number
        System.out.print("Odczyt nr. ser. TeleTokenu:");
        ret=TVTT.GetSerialNr(10);
        if (ret==TeleToken.TVTTS_OK)
            System.out.println("     OK");
        else
            System.out.println(String.format("     %X:%02X",ret>>8,ret&0xFF));
            
        System.out.println(String.format("Numer seryjny:\t\t  %02X%02X%02X%02X", TVTT.SerialNr[0], TVTT.SerialNr[1], TVTT.SerialNr[2], TVTT.SerialNr[3]));
        

        // rozpoczecie sesji / start session
        System.out.print("Rozpoczecie sesji:");
        ret = TVTT.StartSession(1);
        if (ret != 0)
            System.out.println("\t      " + String.format("%X:%02X", ret>>8, ret&0xFF));
        else
            System.out.println("\t      OK");

        // format TeleTokenu / token format
        System.out.print("Format TeleTokenu:");
        TVTT.ZeroMemory(TVTT.OutDataA, 16);
        TVTT.ZeroMemory(TVTT.OutDataB, 16);
        TVTT.ZeroMemory(TVTT.InDataA, 16);
        TVTT.ZeroMemory(TVTT.InDataB, 16);
        TVTT.OutKey = 0;                                                        // znacznik wiadomosci nie szyfrowanej / this message is not encrypted
        TVTT.OutDataB[TeleToken.TVTTD_CMD] = TeleToken.TVTTC_FORMAT;            // rozkaz formatowania TeleTokenu / token format command
        TVTT.OutDataB[TeleToken.TVTTD_PARAM1] = 1;                              // najmłodszy bajt ID odbiorcy TeleTokenu / least significant byte of token user ID

        TVTT.OutDataA[0] = FormatPass[0];
        TVTT.OutDataA[1] = FormatPass[1];
        TVTT.OutDataA[2] = FormatPass[2];
        TVTT.OutDataA[3] = FormatPass[3];
        TVTT.OutDataA[4] = FormatPass[4];

        // numer seryjny
        TVTT.OutDataA[5] = 0x01;
        TVTT.OutDataA[6] = 0x02;
        TVTT.OutDataA[7] = 0x03;
        TVTT.OutDataA[8] = 0x04;

        TVTT.Calc(TVTT.OutDataA, TVTT.OutDataB);                                // policzenie bloku kontrolnego / calculate control data block
        ret = TVTT.Talk(800);
        if (ret == 0x0600)
            System.out.println("\t      Restart TeleTokenu...");
        else
            System.out.println(String.format("\t      %X:%02X", ret>>8, ret&0xFF));

        // zakończenie sesji / end session
        System.out.print("Zakonczenie sesji:");
        ret = TVTT.EndSession();
        if (ret != 0)
            System.out.println(String.format("\t      %X:%02X", ret>>8, ret&0xFF));
        else
            System.out.println("\t      OK");
        
        //zwolnienie uchwytu i zasobów, zamknięcie dostępu do tokenu / close access to the token, free handle & resources
        ret = TVTT.FreeToken();
        System.out.print("Zamknięcie dostępu do tokenu: ");
        if (ret==TeleToken.TVTTS_OK)
            System.out.println("  OK");
        else
            System.out.println(String.format("  0x%2x", ret));
    }

}
